Index: /code/branches/core4/src/core/input/InputState.cc
===================================================================
--- /code/branches/core4/src/core/input/InputState.cc	(revision 3274)
+++ /code/branches/core4/src/core/input/InputState.cc	(revision 3274)
@@ -0,0 +1,130 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "InputState.h"
+#include "core/Functor.h"
+
+namespace orxonox
+{
+    InputState::InputState()
+        : priority_(0)
+        , bAlwaysGetsInput_(false)
+        , bTransparent_(false)
+        , bExpired_(true)
+        , handlers_(2)
+        , joyStickHandlerAll_(0)
+        , enterFunctor_(0)
+        , leaveFunctor_(0)
+    {
+    }
+
+    bool InputState::isInputDeviceEnabled(unsigned int device)
+    {
+        if (device < handlers_.size())
+            return handlers_[device] != NULL;
+        else
+            return false;
+    }
+
+    void InputState::JoyStickQuantityChanged(unsigned int n)
+    {
+        unsigned int oldSize = handlers_.size();
+        handlers_.resize(InputDeviceEnumerator::FirstJoyStick + n, NULL);
+
+        for (unsigned int i = oldSize; i < handlers_.size(); ++i)
+            handlers_[i] = joyStickHandlerAll_;
+
+        bExpired_ = true;
+    }
+
+    /**
+    @brief
+        Adds a joy stick handler.
+    @param handler
+        Pointer to the handler object.
+    @param joyStickID
+        ID of the joy stick
+    @return
+        True if added, false otherwise.
+    */
+    bool InputState::setJoyStickHandler(InputHandler* handler, unsigned int joyStick)
+    {
+        unsigned device = joyStick + firstJoyStickIndex_s;
+        if (joyStick >= handlers_.size() - device)
+            return false;
+
+        handlers_[device] = handler;
+        bExpired_ = true;
+        return true;
+    }
+
+    /**
+    @brief
+        Adds a joy stick handler.
+    @param handler
+        Pointer to the handler object.
+    @return
+        True if added, false if handler already existed.
+    */
+    bool InputState::setJoyStickHandler(InputHandler* handler)
+    {
+        joyStickHandlerAll_ = handler;
+        for (unsigned int i = firstJoyStickIndex_s; i < handlers_.size(); ++i)
+            handlers_[i] = handler;
+        bExpired_ = true;
+        return true;
+    }
+
+    /**
+    @brief
+        Adds a handler of any kind. dynamic_cast determines to which list it is added.
+    @param handler
+        Pointer to the handler object.
+    @return
+        True if added, false if handler already existed.
+    */
+    bool InputState::setHandler(InputHandler* handler)
+    {
+        setKeyHandler(handler);
+        setMouseHandler(handler);
+        return setJoyStickHandler(handler);
+    }
+
+    void InputState::entered()
+    {
+        if (enterFunctor_)
+            (*enterFunctor_)();
+            
+    }
+
+    void InputState::left()
+    {
+        if (leaveFunctor_)
+            (*leaveFunctor_)();
+    }
+}
Index: /code/branches/core4/src/core/input/InputState.h
===================================================================
--- /code/branches/core4/src/core/input/InputState.h	(revision 3273)
+++ /code/branches/core4/src/core/input/InputState.h	(revision 3274)
@@ -27,103 +27,133 @@
  */
 
-/**
-@file
-@brief 
-*/
-
 #ifndef _InputState_H__
 #define _InputState_H__
 
-#include "core/CorePrereqs.h"
+#include "InputPrereqs.h"
 
+#include <cassert>
 #include <string>
 #include <vector>
-#include "InputInterfaces.h"
-#include "JoyStickDeviceNumberListener.h"
+
+#include "InputHandler.h"
+#include "JoyStickQuantityListener.h"
 
 namespace orxonox
 {
-    class _CoreExport InputState : public JoyStickDeviceNumberListener
+    class _CoreExport InputState : public JoyStickQuantityListener
     {
         friend class InputManager;
 
+        static const InputDeviceEnumerator::Value keyboardIndex_s      = InputDeviceEnumerator::Keyboard;
+        static const InputDeviceEnumerator::Value mouseIndex_s         = InputDeviceEnumerator::Mouse;
+        static const InputDeviceEnumerator::Value firstJoyStickIndex_s = InputDeviceEnumerator::FirstJoyStick;
+
     public:
+        void setKeyHandler     (InputHandler* handler)
+            { handlers_[keyboardIndex_s] = handler; bExpired_ = true; }
+        void setMouseHandler   (InputHandler* handler)
+            { handlers_[mouseIndex_s]    = handler; bExpired_ = true; }
+        bool setJoyStickHandler(InputHandler* handler, unsigned int joyStick);
+        bool setJoyStickHandler(InputHandler* handler);
+        bool setHandler        (InputHandler* handler);
+
         const std::string& getName() const { return name_; }
         int getPriority()            const { return priority_; }
 
-        bool isInputDeviceEnabled(unsigned int device)
-        {
-            if (device < bInputDeviceEnabled_.size())
-                return bInputDeviceEnabled_[device];
-            else
-                return false;
-        }
+        bool isInputDeviceEnabled(unsigned int device);
 
-        bool handlersChanged() { return this->bHandlersChanged_; }
-        void resetHandlersChanged() { bHandlersChanged_ = false; }
+        bool hasExpired()      { return this->bExpired_; }
+        void resetExpiration() { bExpired_ = false; }
 
-        virtual void onEnter() = 0;
-        virtual void onLeave() = 0;
+        void update(float dt, unsigned int device);
+        void update(float dt);
 
-        virtual void registerOnEnter(Executor* executor)      { executorOnEnter_ = executor; }
-        virtual void unRegisterOnEnter()                      { executorOnEnter_ = 0; }
-        virtual void registerOnLeave(Executor* executor)      { executorOnLeave_ = executor; }
-        virtual void unRegisterOnLeave()                      { executorOnLeave_ = 0; }
+        template <typename EventType, class Traits>
+        void buttonEvent(unsigned int device, const typename Traits::ButtonTypeParam button);
 
-        virtual void updateInput(float dt, unsigned int device) = 0;
-        virtual void updateInput(float dt) = 0;
+        void mouseMoved(IntVector2 abs, IntVector2 rel, IntVector2 clippingSize);
+        void mouseScrolled(int abs, int rel);
+        void joyStickAxisMoved(unsigned int device, unsigned int axis, float value);
 
-        virtual void keyPressed (const KeyEvent& evt) = 0;
-        virtual void keyReleased(const KeyEvent& evt) = 0;
-        virtual void keyHeld    (const KeyEvent& evt) = 0;
-
-        virtual void mouseButtonPressed (MouseButtonCode::ByEnum id) = 0;
-        virtual void mouseButtonReleased(MouseButtonCode::ByEnum id) = 0;
-        virtual void mouseButtonHeld    (MouseButtonCode::ByEnum id) = 0;
-        virtual void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize) = 0;
-        virtual void mouseScrolled      (int abs, int rel) = 0;
-
-        virtual void joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
-        virtual void joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
-        virtual void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id) = 0;
-        virtual void joyStickAxisMoved     (unsigned int joyStickID, unsigned int axis, float value) = 0;
-
-    protected:
-        InputState()
-            : bHandlersChanged_(false)
-            , executorOnEnter_(0)
-            , executorOnLeave_(0)
-            , priority_(0)
-            , bAlwaysGetsInput_(false)
-            , bTransparent_(false)
-        { }
-        virtual ~InputState() { }
-
-        virtual void numberOfJoySticksChanged(unsigned int n) = 0;
-        void setInputDeviceEnabled(unsigned int device, bool bEnabled)
-        {
-            if (device < bInputDeviceEnabled_.size())
-                bInputDeviceEnabled_[device] = bEnabled;
-        }
-
-        bool bHandlersChanged_;
-        Executor*                                   executorOnEnter_;
-        Executor*                                   executorOnLeave_;
+        // Functors
+        void entered();
+        void left();
+        void setEnterFunctor(Functor* functor) { this->enterFunctor_ = functor; }
+        void setLeaveFunctor(Functor* functor) { this->leaveFunctor_ = functor; }
 
     private:
-        void JoyStickDeviceNumberChanged(unsigned int n)
+        InputState();
+        ~InputState() { }
+
+        void JoyStickQuantityChanged(unsigned int n);
+
+        void setName(const std::string& name) { name_ = name; }
+        void setPriority(int priority)        { priority_ = priority; }
+
+        std::string                 name_;
+        int                         priority_;
+        bool                        bAlwaysGetsInput_;
+        bool                        bTransparent_;
+        bool                        bExpired_;
+        std::vector<InputHandler*>  handlers_;
+        InputHandler*               joyStickHandlerAll_;
+        Functor*                    enterFunctor_;
+        Functor*                    leaveFunctor_;
+    };
+
+    inline void InputState::update(float dt)
+    {
+        for (unsigned int i = 0; i < handlers_.size(); ++i)
+            if (handlers_[i] != NULL)
+                handlers_[i]->allDevicesUpdated(dt);
+    }
+
+    inline void InputState::update(float dt, unsigned int device)
+    {
+        switch (device)
         {
-            bInputDeviceEnabled_.resize(n + 2);
-            numberOfJoySticksChanged(n);
+        case InputDeviceEnumerator::Keyboard:
+            if (handlers_[keyboardIndex_s] != NULL)
+                handlers_[keyboardIndex_s]->keyboardUpdated(dt);
+            break;
+
+        case InputDeviceEnumerator::Mouse:
+            if (handlers_[mouseIndex_s] != NULL)
+                handlers_[mouseIndex_s]->mouseUpdated(dt);
+            break;
+
+        default: // joy sticks
+            if (handlers_[device] != NULL)
+                handlers_[device]->joyStickUpdated(device - firstJoyStickIndex_s, dt);
+            break;
         }
-        void setName(const std::string& name)  { name_ = name; }
-        void setPriority(int priority)         { priority_ = priority; }
+    }
 
-        std::string                                 name_;
-        int                                         priority_;
-        std::vector<bool>                           bInputDeviceEnabled_;
-        bool                                        bAlwaysGetsInput_;
-        bool                                        bTransparent_;
-    };
+    template <typename EventType, class Traits>
+    inline void InputState::buttonEvent(unsigned int device, const typename Traits::ButtonTypeParam button)
+    {
+        assert(device < handlers_.size());
+        if (handlers_[device] != NULL)
+            handlers_[device]->buttonEvent(device, button, EventType());
+    }
+
+    inline void InputState::mouseMoved(IntVector2 abs, IntVector2 rel, IntVector2 clippingSize)
+    {
+        if (handlers_[mouseIndex_s] != NULL)
+            handlers_[mouseIndex_s]->mouseMoved(abs, rel, clippingSize);
+    }
+
+    inline void InputState::mouseScrolled(int abs, int rel)
+    {
+        if (handlers_[mouseIndex_s] != NULL)
+            handlers_[mouseIndex_s]->mouseScrolled(abs, rel);
+    }
+
+    inline void InputState::joyStickAxisMoved(unsigned int device, unsigned int axis, float value)
+    {
+        assert(device < handlers_.size());
+        if (handlers_[device] != NULL)
+            handlers_[device]->axisMoved(device - firstJoyStickIndex_s, axis, value);
+    }
 }
 
Index: /code/branches/core4/src/core/input/JoyStick.cc
===================================================================
--- /code/branches/core4/src/core/input/JoyStick.cc	(revision 3273)
+++ /code/branches/core4/src/core/input/JoyStick.cc	(revision 3274)
@@ -26,10 +26,4 @@
  *
  */
-
-/**
-@file
-@brief
-    Implementation of the JoyStick wrapper class.
-*/
 
 #include "JoyStick.h"
@@ -54,30 +48,26 @@
     void loadCalibration(std::vector<int>& list, const std::string& sectionName, const std::string& valueName, size_t size, int defaultValue);
 
-    JoyStick::JoyStick(const std::vector<InputState*>& states, unsigned int id)
-        : id_(id)
-        , bCalibrating_(false)
-        , inputStates_(states)
+    JoyStick::JoyStick(unsigned int id)
+        : super(id)
     {
         RegisterRootObject(JoyStick);
         this->setConfigValues();
-
-        OIS::InputManager* system = InputManager::getInstance().getInputSystem();
-        oisJoyStick_ = static_cast<OIS::JoyStick*>(system->createInputObject(OIS::OISJoyStick, true));
-        oisJoyStick_->setEventCallback(this);
+        // Initialise POV and Slider states
+        this->clearBuffersImpl();
 
         idString_ = "JoyStick_";
-        std::string name = oisJoyStick_->vendor();
+        std::string name = oisDevice_->vendor();
         replaceCharacters(name, ' ', '_');
         idString_ += name + "_";
-        idString_ += multi_cast<std::string>(oisJoyStick_->getNumberOfComponents(OIS::OIS_Button))  + "_";
-        idString_ += multi_cast<std::string>(oisJoyStick_->getNumberOfComponents(OIS::OIS_Axis))    + "_";
-        idString_ += multi_cast<std::string>(oisJoyStick_->getNumberOfComponents(OIS::OIS_Slider))  + "_";
-        idString_ += multi_cast<std::string>(oisJoyStick_->getNumberOfComponents(OIS::OIS_POV));
-        //idString_ += multi_cast<std::string>(oisJoyStick_->getNumberOfComponents(OIS::OIS_Vector3));
+        idString_ += multi_cast<std::string>(oisDevice_->getNumberOfComponents(OIS::OIS_Button))  + "_";
+        idString_ += multi_cast<std::string>(oisDevice_->getNumberOfComponents(OIS::OIS_Axis))    + "_";
+        idString_ += multi_cast<std::string>(oisDevice_->getNumberOfComponents(OIS::OIS_Slider))  + "_";
+        idString_ += multi_cast<std::string>(oisDevice_->getNumberOfComponents(OIS::OIS_POV));
+        //idString_ += multi_cast<std::string>(oisDevice_->getNumberOfComponents(OIS::OIS_Vector3));
 
         if (InputManager::getInstance().checkJoyStickID(idString_) == false)
         {
             // Make the ID unique for this execution time.
-            idString_ += "_" + multi_cast<std::string>(id_);
+            idString_ += "_" + multi_cast<std::string>(this->getDeviceID());
         }
 
@@ -85,5 +75,5 @@
 
         // Load calibration
-        size_t axes = sliderAxes_s + static_cast<size_t>(oisJoyStick_->getNumberOfComponents(OIS::OIS_Axis));
+        size_t axes = sliderAxes_s + static_cast<size_t>(oisDevice_->getNumberOfComponents(OIS::OIS_Axis));
         loadCalibration(configMinValues_,  idString_, "MinValue",  axes,  -32768);
         loadCalibration(configMaxValues_,  idString_, "MaxValue",  axes,   32768);
@@ -92,21 +82,5 @@
     }
 
-    JoyStick::~JoyStick()
-    {
-        try
-        {
-            OIS::InputManager* system = InputManager::getInstance().getInputSystem();
-            system->destroyInputObject(oisJoyStick_);
-        }
-        catch (...)
-        {
-            COUT(1) << "Joy stick destruction failed! Potential resource leak!" << std::endl;
-        }
-    }
-
-    /**
-    @brief
-        Callback for the joy stick calibration config file. @see setConfigValues.
-    */
+    //!< Callback for the joy stick calibration config file.
     void JoyStick::calibrationFileCallback()
     {
@@ -114,8 +88,4 @@
     }
 
-    /**
-    @brief
-        Sets the configurable values.
-    */
     void JoyStick::setConfigValues()
     {
@@ -140,13 +110,10 @@
         // fill the rest with default values
         for (unsigned int i = configValueVectorSize; i < size; ++i)
-        {
             list[i] = defaultValue;
-        }
-    }
-
-    void JoyStick::startCalibration()
-    {
-        bCalibrating_ = true;
-
+    }
+
+    //! Called by InputDevice when calibration mode has started
+    void JoyStick::calibrationStarted()
+    {
         // Set initial values
         BOOST_FOREACH(int& minVal, configMinValues_)
@@ -158,5 +125,6 @@
     }
 
-    void JoyStick::stopCalibration()
+    //! Called by InputDevice when calibration mode has stopped
+    void JoyStick::calibrationStopped()
     {
         // Get the middle positions now
@@ -164,11 +132,11 @@
         for (unsigned int i = 0; i < sliderAxes_s/2; ++i)
         {
-            configZeroValues_[iAxis++] = oisJoyStick_->getJoyStickState().mSliders[i].abX;
-            configZeroValues_[iAxis++] = oisJoyStick_->getJoyStickState().mSliders[i].abY;
-        }
-        // Note: joyStickMiddleValues_[iJoyStick] was already correctly resised in loadCalibration()
-        assert(oisJoyStick_->getJoyStickState().mAxes.size() == configZeroValues_.size() - sliderAxes_s);
+            configZeroValues_[iAxis++] = oisDevice_->getJoyStickState().mSliders[i].abX;
+            configZeroValues_[iAxis++] = oisDevice_->getJoyStickState().mSliders[i].abY;
+        }
+        // Note: joyStickZeroValues_[iJoyStick] was already correctly resised in loadCalibration()
+        assert(oisDevice_->getJoyStickState().mAxes.size() == configZeroValues_.size() - sliderAxes_s);
         for (unsigned int i = 0; i < configZeroValues_.size() - sliderAxes_s; ++i)
-            configZeroValues_[iAxis++] = oisJoyStick_->getJoyStickState().mAxes[i].abs;
+            configZeroValues_[iAxis++] = oisDevice_->getJoyStickState().mAxes[i].abs;
 
         for (unsigned int i = 0; i < configMinValues_.size(); ++i)
@@ -192,8 +160,7 @@
 
         this->evaluateCalibration();
-
-        bCalibrating_ = false;
-    }
-
+    }
+
+    //! Evaluates the accumulated values during calibration
     void JoyStick::evaluateCalibration()
     {
@@ -206,7 +173,7 @@
     }
 
-    void JoyStick::clearBuffer()
-    {
-        pressedButtons_.clear();
+    // TODO: What do we really need to reset here?
+    void JoyStick::clearBuffersImpl()
+    {
         for (int j = 0; j < 4; ++j)
         {
@@ -217,60 +184,8 @@
     }
 
-
-    // ###### Events ######
-
-    void JoyStick::capture()
-    {
-        oisJoyStick_->capture();
-
-        // call all the handlers for the held joy stick button events
-        for (unsigned int iButton = 0; iButton < pressedButtons_.size(); iButton++)
-        {
-            BOOST_FOREACH(InputState* state, inputStates_)
-                state->joyStickButtonHeld(id_, pressedButtons_[iButton]);
-        }
-    }
-
-    bool JoyStick::buttonPressed(const OIS::JoyStickEvent &arg, int button)
-    {
-        // check whether the button already is in the list (can happen when focus was lost)
-        unsigned int iButton = 0;
-        while (iButton < pressedButtons_.size() && pressedButtons_[iButton] != button)
-            iButton++;
-        if (iButton == pressedButtons_.size())
-            pressedButtons_.push_back(static_cast<JoyStickButtonCode::ByEnum>(button));
-
-        BOOST_FOREACH(InputState* state, inputStates_)
-            state->joyStickButtonPressed(id_, static_cast<JoyStickButtonCode::ByEnum>(button));
-
-        return true;
-    }
-
-    bool JoyStick::buttonReleased(const OIS::JoyStickEvent &arg, int button)
-    {
-        // remove the button from the pressedButtons_ list
-        for (unsigned int iButton = 0; iButton < pressedButtons_.size(); iButton++)
-        {
-            if (static_cast<int>(pressedButtons_[iButton]) == button)
-            {
-                pressedButtons_.erase(pressedButtons_.begin() + iButton);
-                break;
-            }
-        }
-
-        BOOST_FOREACH(InputState* state, inputStates_)
-            state->joyStickButtonPressed(id_, static_cast<JoyStickButtonCode::ByEnum>(button));
-
-        return true;
-    }
-
-    /**
-    @brief
-        Calls the states for a particular axis with our enumeration.
-        Used by OIS sliders and OIS axes.
-    */
+    //! Generic method to forward axis events
     void JoyStick::fireAxis(int axis, int value)
     {
-        if (bCalibrating_)
+        if (this->isCalibrating())
         {
             if (value < configMinValues_[axis])
@@ -288,8 +203,9 @@
 
             BOOST_FOREACH(InputState* state, inputStates_)
-                state->joyStickAxisMoved(id_, axis, fValue);
-        }
-    }
-
+                state->joyStickAxisMoved(this->getDeviceID(), axis, fValue);
+        }
+    }
+
+    //! OIS joy stick axis event handler
     bool JoyStick::axisMoved(const OIS::JoyStickEvent &arg, int axis)
     {
@@ -300,4 +216,5 @@
     }
 
+    //! A Slider always has an X and an Y direction!
     bool JoyStick::sliderMoved(const OIS::JoyStickEvent &arg, int id)
     {
@@ -310,4 +227,5 @@
     }
 
+    //! A POV is the big button that can point in all directions (but only in one at once)
     bool JoyStick::povMoved(const OIS::JoyStickEvent &arg, int id)
     {
Index: /code/branches/core4/src/core/input/JoyStick.h
===================================================================
--- /code/branches/core4/src/core/input/JoyStick.h	(revision 3273)
+++ /code/branches/core4/src/core/input/JoyStick.h	(revision 3274)
@@ -27,82 +27,90 @@
  */
 
-/**
-@file
-@brief 
-*/
+#ifndef _Core_JoyStick_H__
+#define _Core_JoyStick_H__
 
-#ifndef _JoyStick_H__
-#define _JoyStick_H__
-
-#include "core/CorePrereqs.h"
+#include "InputPrereqs.h"
 
 #include <string>
 #include <vector>
-#include "InputInterfaces.h"
+#include "InputDevice.h"
 
 namespace orxonox
 {
-    class _CoreExport JoyStick : public OrxonoxClass, public OIS::JoyStickListener
+    /**
+    @brief
+        Wraps around an OIS::JoyStick and forwards the input events to
+        a list of input states.
+
+        The class also supports joy stick calibration and stores the values
+        in an ini-file.
+    */
+    class _CoreExport JoyStick
+        : public OrxonoxClass
+        , public InputDeviceTemplated<JoyStickTraits>
+        , public OIS::JoyStickListener
     {
-    private:
-        struct JoyStickCalibration
-        {
-        };
+        friend class InputDeviceTemplated<JoyStickTraits>;
+        //! Super class alias
+        typedef InputDeviceTemplated<JoyStickTraits> super;
 
     public:
-        JoyStick(const std::vector<InputState*>& states, unsigned int id);
-        ~JoyStick();
-
+        //! Assigns a generated ID string and loads the calibration (if present)
+        JoyStick(unsigned int id);
+        ~JoyStick() { }
         void setConfigValues();
 
-        OIS::JoyStick* getOISJoyStick() { return this->oisJoyStick_; }
+        //! Returns the generated (from the number of knobs and the device name) ID string
         const std::string& getIDString() const { return this->idString_; }
 
-        void startCalibration();
-        void stopCalibration();
+    private:
+        void calibrationStarted();
+        void calibrationStopped();
+        void evaluateCalibration();
 
-        void capture();
-        void clearBuffer();
-
-    private:
+        void clearBuffersImpl();
         void calibrationFileCallback();
-        void evaluateCalibration();
         void fireAxis(int axis, int value);
 
-        bool buttonPressed (const OIS::JoyStickEvent &arg, int button);
-        bool buttonReleased(const OIS::JoyStickEvent &arg, int button);
+        //! OIS event handler
+        bool buttonPressed (const OIS::JoyStickEvent &arg, int button)
+        {
+            super::buttonPressed(static_cast<JoyStickButtonCode::ByEnum>(button));
+            return true;
+        }
+
+        //! OIS event handler
+        bool buttonReleased(const OIS::JoyStickEvent &arg, int button)
+        {
+            super::buttonReleased(static_cast<JoyStickButtonCode::ByEnum>(button));
+            return true;
+        }
+
         bool axisMoved     (const OIS::JoyStickEvent &arg, int axis);
         bool sliderMoved   (const OIS::JoyStickEvent &arg, int id);
         bool povMoved      (const OIS::JoyStickEvent &arg, int id);
-        // don't remove that! Or else add OIS as dependency library to orxonox (it actually is..)
+        //!< OIS event handler (don't remove that because of OIS version issues!)
         bool vector3Moved  (const OIS::JoyStickEvent &arg, int id) { return true; }
 
-        static const unsigned int sliderAxes_s = 8;
-
-        OIS::JoyStick* oisJoyStick_;
-        const unsigned int id_;
-        std::string idString_;
+        std::string idString_;                //!< ID string generated by the number of knobs and the device name
+        int povStates_[4];                    //!< Internal states for the POVs
+        int sliderStates_[4][2];              //!< Internal states for the Sliders (each slider has X and Y!)
 
         // calibration
-        bool bCalibrating_;
-        int zeroValues_[24];
-        float positiveCoeffs_[24];
-        float negativeCoeffs_[24];
+        int zeroValues_[24];                  //!< Axes values when the knob is in the middle
+        float positiveCoeffs_[24];            //!< Maps the negative part of an axis to a 0.0 to 1.0 floating range
+        float negativeCoeffs_[24];            //!< Maps the positive part of an axis to a 0.0 to 1.0 floating range
 
-        std::vector<int> configMinValues_;
-        std::vector<int> configMaxValues_;
-        std::vector<int> configZeroValues_;
-
-        int povStates_[4];
-        int sliderStates_[4][2];
-        std::vector<JoyStickButtonCode::ByEnum> pressedButtons_;
-
-        // InputState handling
-        const std::vector<InputState*>& inputStates_;
+        std::vector<int> configZeroValues_;   //!< Config file stored axis values when the knob is in the middle
+        std::vector<int> configMinValues_;    //!< Config file stored minimum axis values
+        std::vector<int> configMaxValues_;    //!< Config file stored maximum axis values
 
         // ConfigValues
-        std::string calibrationFilename_;  //!< Joy stick calibration ini filename
+        std::string calibrationFilename_;     //!< Joy stick calibration ini filename
+
+        //!< Maximum number of slider axes
+        static const unsigned int sliderAxes_s = 8;
     };
 }
 
-#endif /* _JoyStick_H__ */
+#endif /* _Core_JoyStick_H__ */
Index: /code/branches/core4/src/core/input/JoyStickQuantityListener.cc
===================================================================
--- /code/branches/core4/src/core/input/JoyStickQuantityListener.cc	(revision 3274)
+++ /code/branches/core4/src/core/input/JoyStickQuantityListener.cc	(revision 3274)
@@ -0,0 +1,44 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Implementation of the JoyStickQuantityListener class.
+*/
+
+#include "JoyStickQuantityListener.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    JoyStickQuantityListener::JoyStickQuantityListener()
+    {
+        RegisterObject(JoyStickQuantityListener);
+    }
+}
Index: /code/branches/core4/src/core/input/JoyStickQuantityListener.h
===================================================================
--- /code/branches/core4/src/core/input/JoyStickQuantityListener.h	(revision 3274)
+++ /code/branches/core4/src/core/input/JoyStickQuantityListener.h	(revision 3274)
@@ -0,0 +1,52 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief 
+*/
+
+#ifndef _JoyStickQuantityListener_H__
+#define _JoyStickQuantityListener_H__
+
+#include "InputPrereqs.h"
+#include "core/OrxonoxClass.h"
+
+namespace orxonox
+{
+    class _CoreExport JoyStickQuantityListener : virtual public OrxonoxClass
+    {
+    public:
+        JoyStickQuantityListener();
+        virtual ~JoyStickQuantityListener() { }
+
+        virtual void JoyStickQuantityChanged(unsigned int value) = 0;
+    };
+}
+
+#endif /* _JoyStickQuantityListener_H__ */
